Attribute VB_Name = "modRuntime"
Option Explicit
Type OBJTYPE
  Code() As Byte
  KindOf As Byte
  LocVarSpace As Long
  IsExecutable As Boolean
  Obj As Object
End Type
Type FRMDATA
  Objects() As OBJTYPE
  MaxObj As Long
  FormObj As frm
  Obj As Object
End Type
Type DATA
  Code() As Byte
  MaxCode As Long
  InstPointer As Long
  EventNum As Long
  FormId As Long
  LocVarSpace As Long
  LocVarInit As Long
  Params As Long
End Type
Dim TwpX As Long, TwpY As Long
Public Frms() As FRMDATA
Public StringArray() As String
Public Labels() As Long
Public Here As String

Sub Main()
  Dim i As Long, ip As Long, TmpLng As Long

  TwpX = Screen.TwipsPerPixelX
  TwpY = Screen.TwipsPerPixelY
  Here = App.Path
  If Right(Here, 1) <> "\" Then Here = Here + "\"
  Open Here + App.EXEName & ".exe" For Binary Access Read As #1
  'Open Here + "Program.exe" For Binary Access Read As #1
  Get 1, LOF(1) - 3, TmpLng
  Get 1, TmpLng, TmpLng
  SetGlobMemSpace TmpLng
  Get 1, , TmpLng
  If TmpLng Then
    ReDim StringArray(TmpLng - 1)
    Get 1, , StringArray
  End If
  Get 1, , TmpLng
  If TmpLng Then
    ReDim Labels(TmpLng - 1)
    Get 1, , Labels
  End If
  Get 1, , TmpLng
  If TmpLng Then ReDim Frms(TmpLng - 1)
  For i = 0 To TmpLng - 1
    With Frms(i)
      Set .FormObj = New frm
      Set .Obj = .FormObj
      Load .FormObj
      Get 1, , .MaxObj
      If .MaxObj Then ReDim .Objects(.MaxObj - 1)
      .FormObj.Tag = i
      For ip = 0 To .MaxObj - 1
        With .Objects(ip)
          Get 1, , .KindOf
          Get 1, , .LocVarSpace
          Get 1, , TmpLng
          If TmpLng Then
            .IsExecutable = True
            ReDim .Code(TmpLng - 1)
            Get 1, , .Code
          End If
          Select Case .KindOf
            Case 0, 8
            Case 1
              With Frms(i).FormObj
                TmpLng = .cmd.UBound + 1
                Load .cmd(TmpLng)
                With .cmd(TmpLng)
                  .Tag = ip
                  .Visible = True
                End With
              End With
              Set .Obj = Frms(i).FormObj.cmd(TmpLng)
            Case 2
              With Frms(i).FormObj
                TmpLng = .chk.UBound + 1
                Load .chk(TmpLng)
                With .chk(TmpLng)
                  .Tag = ip
                  .Visible = True
                End With
              End With
              Set .Obj = Frms(i).FormObj.chk(TmpLng)
            Case 3
              With Frms(i).FormObj
                TmpLng = .lbl.UBound + 1
                Load .lbl(TmpLng)
                With .lbl(TmpLng)
                  .Tag = ip
                  .Visible = True
                End With
              End With
              Set .Obj = Frms(i).FormObj.lbl(TmpLng)
            Case 4
              With Frms(i).FormObj
                TmpLng = .lst.UBound + 1
                Load .lst(TmpLng)
                With .lst(TmpLng)
                  .Tag = ip
                  .Visible = True
                End With
              End With
              Set .Obj = Frms(i).FormObj.lst(TmpLng)
            Case 5
              With Frms(i).FormObj
                TmpLng = .txt.UBound + 1
                Load .txt(TmpLng)
                With .txt(TmpLng)
                  .Tag = ip
                  .Visible = True
                End With
              End With
              Set .Obj = Frms(i).FormObj.txt(TmpLng)
            Case 6
              With Frms(i).FormObj
                TmpLng = .mem.UBound + 1
                Load .mem(TmpLng)
                With .mem(TmpLng)
                  .Tag = ip
                  .Visible = True
                End With
              End With
              Set .Obj = Frms(i).FormObj.mem(TmpLng)
            Case 7
              With Frms(i).FormObj
                TmpLng = .tmr.UBound + 1
                Load .tmr(TmpLng)
                .tmr(TmpLng).Tag = ip
              End With
              Set .Obj = Frms(i).FormObj.tmr(TmpLng)
            Case Else
              PopError 7
          End Select
        End With
      Next ip
    End With
  Next i
  Close
  With Frms(0).FormObj
    .FormLoaded
    .Show
  End With
End Sub

Function DoExec(ByVal FormId As Long, ByVal ObjId As Long, Optional ByVal EventId As Long = -1, Optional ByVal ParamPassed As Long) As String
  Dim Dat As DATA

  On Error GoTo HuboErr
  With Frms(FormId).Objects(ObjId)
    If .IsExecutable Then
      Dat.Code = .Code
      Dat.MaxCode = UBound(.Code)
      Dat.LocVarSpace = .LocVarSpace
      Dat.EventNum = EventId
      Dat.FormId = FormId
      Dat.Params = ParamPassed
      DoExec = Execute(Dat)
    End If
  End With
  Exit Function
HuboErr:
  Select Case Err.Number
    Case 11
      PopError 8
    Case 13
      PopError 2
    Case 5
      PopError 3
    Case Else
      PopError 4
  End Select
End Function

Function Execute(Dat As DATA) As String
  With Dat
    .LocVarInit = AllocBytes(.LocVarSpace)
    If .Params Then PopParams Dat
    Do While .InstPointer < .MaxCode
      Select Case GetNext2(Dat)
        Case 12100 'end
          End
        Case 12110 'exit
          Exit Do
        Case 12300 'show form
          With Frms(GetNext2(Dat)).FormObj
            .FormLoaded
            .Show IIf(GetNext1(Dat) = 1, vbModal, 0)
          End With
        Case 12310 'show obj
          Frms(Dat.FormId).Objects(GetNext2(Dat)).Obj.Visible = True
        Case 12301 'hide form
          Frms(GetNext2(Dat)).FormObj.Hide
        Case 12311 'hide obj
          Frms(Dat.FormId).Objects(GetNext2(Dat)).Obj.Visible = False
        Case 12400 'message
          MsgBox Expression(Dat), Expression(Dat), Expression(Dat)
        Case 12411 '<assignment>
          SetVar Dat
        Case 12500 'redim
          DoRedim GetVarAddr(Dat), GetNext2(Dat), Expression(Dat)
        Case 12510 'redim preserve
          DoRedimPreserve GetVarAddr(Dat), GetNext2(Dat), Expression(Dat)
        Case 12600 'if
          If Expression(Dat) Then
            GetNext2 Dat
          Else
            Dat.InstPointer = Labels(GetNext2(Dat))
          End If
        Case 12605 'if not
          If Expression(Dat) Then
            Dat.InstPointer = Labels(GetNext2(Dat))
          Else
            GetNext2 Dat
          End If
        Case 12610 'goto
          Dat.InstPointer = Labels(GetNext2(Dat))
        Case 12700 'push
          Push GetVarAddr(Dat)
        Case 12705 'pop
          Pop
        Case 12720 'call
          PerformCall GetNext2(Dat), GetNext2(Dat), Dat
        Case 12730 'return
          Execute = Expression(Dat)
          Exit Do
        Case 12740 'setprop
          SetObjProp Frms(GetNext2(Dat)).Objects(GetNext2(Dat)).Obj, GetNext2(Dat), Expression(Dat)
        Case 12745 'setformprop
          SetObjProp Frms(GetNext2(Dat)).Obj, GetNext2(Dat), Expression(Dat)
        Case 12750 'call noparam
          DoExec GetNext2(Dat), GetNext2(Dat)
        Case 12760 'method
          ObjMethod Frms(GetNext2(Dat)).Objects(GetNext2(Dat)).Obj, GetNext2(Dat), Dat
        Case Else
          PopError 0
      End Select
    Loop
  End With
  UnallocBytes Dat.LocVarInit
End Function

Function PerformCall(ByVal FormId As Long, ByVal ObjId As Long, Dat As DATA) As String
  Dim i As Long, Ret As Long, Max As Long, ParamSize As Long

  Max = GetNext2(Dat)
  For i = 1 To Max
    Ret = GetNext2(Dat)
    Select Case Ret
      Case 4: ParamSize = ParamSize + 16
      Case 3, 0: ParamSize = ParamSize + 4
      Case 2: ParamSize = ParamSize + 1
      Case 1: ParamSize = ParamSize + 8
    End Select
    Select Case Ret
      Case 0, 1, 2, 4
        Push Expression(Dat)
      Case 3
        Push GetVarAddr(Dat)
    End Select
    Push Ret
  Next i
  Push ParamSize
  PerformCall = DoExec(FormId, ObjId, , Max)
End Function

Private Sub PopParams(Dat As DATA)
  Dim i As Long, ParamVar As Long

  ParamVar = Dat.LocVarInit + Val(Pop())
  For i = Dat.Params - 1 To 0 Step -1
    Select Case Val(Pop())
      Case 0
        ParamVar = ParamVar - 4
        PutMemStr ParamVar, Pop()
      Case 1
        ParamVar = ParamVar - 8
        PutMem8 ParamVar, Pop()
      Case 2
        ParamVar = ParamVar - 1
        PutMem1 ParamVar, Pop()
      Case 3
        ParamVar = ParamVar - 4
        PutMem4 ParamVar, Pop()
      Case 4
        ParamVar = ParamVar - 16
        PutMemVar ParamVar, Pop()
    End Select
  Next i
End Sub

Sub SetObjProp(Obj As Object, ByVal PropId As Long, Value As Variant)
  Select Case PropId
    Case 1 'x
      Obj.Left = Value * TwpX
    Case 2 'y
      Obj.Top = Value * TwpY
    Case 3 'width
      Obj.Width = Value * TwpX
    Case 4 'height
      Obj.Height = Value * TwpY
    Case 5 'caption
      Obj.Caption = Value
    Case 6 'text
      Obj.Text = Value
    Case 7, 12 'enabled
      Obj.Enabled = Value
    Case 8 'visible
      Obj.Visible = Value
    Case 9 'listindex
      Obj.ListIndex = Value
    Case 11 'timer
      Obj.Interval = Value
    Case 13 'checked
      If Value Then Obj.Value = 1 Else Obj.Value = 0
  End Select
End Sub

Function GetObjProp(Obj As Object, ByVal PropId As Long)
  Select Case PropId
    Case 1 'x
      GetObjProp = Obj.Left / TwpX
    Case 2 'y
      GetObjProp = Obj.Top / TwpY
    Case 3 'width
      GetObjProp = Obj.Width / TwpX
    Case 4 'height
      GetObjProp = Obj.Height / TwpY
    Case 5 'caption
      GetObjProp = Obj.Caption
    Case 6 'text
      GetObjProp = Obj.Text
    Case 7, 12 'enabled
      GetObjProp = Obj.Enabled
    Case 8 'visible
      GetObjProp = Obj.Visible
    Case 9 'listindex
      GetObjProp = Obj.ListIndex
    Case 10 'listcount
      GetObjProp = Obj.ListCount
    Case 11 'timer
      GetObjProp = Obj.Interval
    Case 13 'checked
      GetObjProp = Obj.Value = 1
  End Select
End Function

Function ObjMethod(Obj As Object, ByVal MethodId As Long, Dat As DATA) As Variant
  Select Case MethodId
    Case 1 'additem
      Obj.AddItem Expression(Dat)
    Case 2 'remoteitem
      Obj.RemoveItem Expression(Dat)
    Case 3 'clear
      Obj.Clear
    Case 4 'list
      ObjMethod = Obj.List(Expression(Dat))
  End Select
End Function

Function FormCount() As Long
  Dim i As Long

  For i = 0 To UBound(Frms)
    If Frms(i).FormObj.Visible Then FormCount = FormCount + 1
  Next i
End Function
