Attribute VB_Name = "modUseful"
Option Explicit

Function GetNext8(Dat As DATA) As Double
  Dim TmpDbl As Double

  With Dat
    CopyMemory TmpDbl, .Code(.InstPointer), Len(TmpDbl)
    .InstPointer = .InstPointer + Len(TmpDbl)
  End With
  GetNext8 = TmpDbl
End Function

Function GetNext4(Dat As DATA) As Long
  Dim TmpLng As Long

  With Dat
    CopyMemory TmpLng, .Code(.InstPointer), Len(TmpLng)
    .InstPointer = .InstPointer + Len(TmpLng)
  End With
  GetNext4 = TmpLng
End Function

'Function GetNext2(Dat As DATA, Optional ByVal PreserveInstPtr As Boolean) As Integer
'  Dim TmpInt As Integer
'
'  With Dat
'    CopyMemory TmpInt, .Code(.InstPointer), Len(TmpInt)
'    If Not PreserveInstPtr Then .InstPointer = .InstPointer + Len(TmpInt)
'  End With
'  GetNext2 = TmpInt
'End Function

Function GetNext2(Dat As DATA) As Integer
  Dim TmpInt As Integer

  With Dat
    CopyMemory TmpInt, .Code(.InstPointer), Len(TmpInt)
    .InstPointer = .InstPointer + Len(TmpInt)
  End With
  GetNext2 = TmpInt
End Function

Function GetNext1(Dat As DATA) As Byte
  With Dat
    GetNext1 = .Code(.InstPointer)
    .InstPointer = .InstPointer + 1
  End With
End Function

Function GetString(ByVal Index As Long) As String
  GetString = StringArray(Index)
End Function

Sub PopError(ErrNum As Integer)
  Dim Mes As String

  Select Case ErrNum
    Case 0
      Mes = "Invalid instruction"
    Case 1
      Mes = "Subscript out of range"
    Case 2
      Mes = "Type mismatch"
    Case 3
      Mes = "Procedure call or argument not valid"
    Case 4
      Mes = "Internal error"
    Case 5
      Mes = "Invalid intrinsic function"
    Case 6
      Mes = "Invalid expression"
    Case 7
      Mes = "Unknown object type"
    Case 8
      Mes = "Division by 0"
'    Case 9
'      Mes = "File does not exists"
'    Case 10
'      Mes = "File number out of range"
'    Case 11
'      Mes = "File not open"
'    Case 12
'      Mes = "File not open or open in wrong mode"
  End Select
  MsgBox "Runtime error occured:" + vbCrLf + vbCrLf + Mes, vbCritical, "Error"
  End
End Sub

