Attribute VB_Name = "modDeclarations"
Option Explicit
Public Const kDecl = 8

Sub CompileDecls()
  For CurForm = 0 To Project.MaxForm - 1
    CompileForm CurForm
  Next
End Sub

Private Sub CompileForm(ByVal FormId As Long)
  With Project.Forms(FormId)
    For CurObj = 0 To .MaxObj - 1
      frmCompile.Calculate CurObj \ .MaxObj + CurForm, Project.MaxForm
      CompileObj FormId, CurObj
    Next
  End With
End Sub

Private Sub CompileObj(ByVal FormId As Long, ByVal ObjId As Long)
  Dim CodeArray() As String

  With Project.Forms(FormId).Objects(ObjId)
    If .KindOf <> kDecl Then Exit Sub
    CodeArray = Split(.Code, vbCrLf)
    For CurLine = 0 To UBound(CodeArray)
      CompileLine CodeArray(CurLine)
    Next
  End With
End Sub

Private Sub CompileLine(CodeLine As String)
  Dim Comienzo As Long, i As Long, TmpLng As Long
  Dim TempVars() As VARINFO

  If GetWords(CodeLine, False) Then AddError 1, False
  If Len(Palabra(0)) = 0 Then Exit Sub
  Select Case LCase$(Palabra(0))
    Case "var"
      Comienzo = 1
      For i = 0 To CompListaVar(Comienzo, TempVars, tsGlobVar) - 1
        With TempVars(i)
          GlobVarAdm 0, .Nomb, .Tipo, .Pointer, .HiBound
        End With
      Next i
    Case "struct"
      If Len(Palabra(1)) = 0 Then AddError 23, False, "Identifier"
      If Not IsValid(Palabra(1)) Then AddError 6, False, Palabra(1)
      TmpLng = TipoAdm(0, 0, Palabra(1))
      If Palabra(2) <> "," Then AddError 23, False, "','"
      Comienzo = 3
      For i = 0 To CompListaVar(Comienzo, TempVars, tsStruct, TmpLng) - 1
        With TempVars(i)
          TipoAdm 1, TmpLng, .Nomb, .Tipo, .Pointer, .HiBound
        End With
      Next i
    Case Else
      AddError 3, False
  End Select
  If Len(Palabra(Comienzo)) Then AddError 23, False, "End of Statement"
End Sub
